<!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Update User</title>

     <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
     <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
     <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
   
</head>
<body>
     <div class="container jumbotron">
          <div class="text-center mb-4">
               <!--row 1-->
               <h3>Chi tiết User</h3>
          </div>
          <div class="row form-group">
               <div class="col-sm-4">
                    <!--col 2.1-->
                    <label>First Name</label>
               </div>
               <div class="col-sm-8">
                    <!--col 2.2-->
                    <input class="form-control" placeholder="Nhập Firstname..." id="inp-firstname" type="text">
               </div>
          </div>
          <div class="row form-group">
               <div class="col-sm-4">
                    <!--col 3.1-->
                    <label>Last Name</label>
               </div>
               <div class="col-sm-8">
                    <!--col 3.2-->
                    <input class="form-control" placeholder="Nhập Lastname..." id="inp-lastname" type="text">
               </div>
          </div>
          <div class="row form-group">
               <div class="col-sm-4">
                    <!--col 4.1-->
                    <label>Subject</label>
               </div>
               <div class="col-sm-8">
                    <!--col 4.2-->
                    <input class="form-control" placeholder="Nhập Subject..." id="inp-subject" type="text">
               </div>
          </div>
          <div class="row form-group">
               <div class="col-sm-4">
                    <!--col 5.1-->
                    <label>Country</label>
               </div>
               <div class="col-sm-8">
                    <!--col 5.2-->
                   <select class="form-control" id="seclect-country" name="Customertype">
                         <option value="VN">Việt Nam</option>
                         <option value="USA">USA</option>
                         <option value="AUS  ">Australia</option>
                         <option value="CAN">Canada</option>
                   </select>
               </div>
          </div>
          <div class="row form-group">
               <div class="col-sm-4">
                    <!--col 6.1-->
                    <label>Customer Type</label>
               </div>
               <div class="col-sm-8">
                    <!--col 6.2-->
                    <select class="form-control" id="select-customertype" name="Customertype"> 
                         <option value="Standard">Standard</option>
                         <option value="Gold">Gold</option>
                         <option value="Premium">Premium</option>
                    </select>
               </div>
          </div>
          <div class="row form-group">
               <div class="col-sm-4">
                    <!--col 7.1-->
                    <label>Register Status</label>
               </div>
               <div class="col-sm-8">
                    <!--col 7.2-->
                    <select class="form-control" id="select-register-status" name="registerStatus"> 
                         <option value="New">New</option>
                         <option value="Accepted">Accepted</option>
                         <option value="Denied">Denied</option>
                    </select>
               </div>
          </div>
          <div class="row form-group">
               <div class="col-sm-4">
                    <!--col 8.1-->
               </div>
               <div class="col-sm-8">
                    <!--col 8.2-->
                    <button type="button" class="btn btn-success w-25" id="btn-update-user">Update User</button>
                    <button type="button" class="btn btn-success w-25" id="btn-update-user">Hủy Bỏ</button>
               </div>
          </div>
     </div>
</body>

<script>
          "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
     const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";   

     var gEleFirstName = $("#inp-firstname");
     var gEleLastName = $("#inp-lastname");
     var gEleCountry  = $("#seclect-country");
     var gEleCustomerType = $("#select-customertype");
     var gEleSubject = $("#inp-subject");
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
     $(document).ready(function(){
          onPageLoading();
     })

     $("#btn-update-user").click(function(){
          console.log("Update User Click");
          //B1: thu thập dữ liệu 
          var vDataObj = getFormData();
          //B2: kiểm tra dữ liệu 
          var vCheck = validateFormData(vDataObj);
          if(vCheck){
               //B3: Gọi API
               callAjaxAPIUpdateUser(vDataObj);
          }
          //B4: xử lý hiển thị 
     });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //hàm xử lý việc tải trang 
     function onPageLoading(){
          "use strict"
          //thu thập dữ liệu 
          var vUrlString = window.location.href;
          var vUrl = new URL(vUrlString);

          //lấy parameter
          var vId = vUrl.searchParams.get("id");
          console.log(vId);

          callAPIGetDataUserById(vId);
     }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  //hàm gọi api
  function callAPIGetDataUserById(paramUserId){
     $.ajax({
          url: "http://203.171.20.210:8080/crud-api/users/" + paramUserId,
          type: "GET", 
          dataType: "json",
          success: function(DataUserObj){
               console.log(DataUserObj);
               //gọi hàm hiển thị thông tin lên form
               showDataUserToForm(DataUserObj);
          }, 
          error: function(ajaxContext){
               alert(ajaxContext.responseText);
          },
     });
  }

  //hàm xử lý load dữ liệu lên form
  function showDataUserToForm(param){
     "use strict"
     $("#inp-firstname").val(param.firstname);
     $("#inp-lastname").val(param.lastname);
     $("#select-country").val(param.country);
     $("#inp-subject").val(param.subject);
     $("#select-customertype").val(param.customerType);
     $("#select-register-status").val(param.registerStatus);
  }
 

  //hàm thu thập dữ liệu 
  function getFormData(){
     var vUpdateInfoObj = new Object();

     vUpdateInfoObj.firstname = $.trim(gEleFirstName.val());
     vUpdateInfoObj.lastname = $.trim(gEleLastName.val());
     vUpdateInfoObj.country = $.trim(gEleCountry.val());
     vUpdateInfoObj.customerType = $.trim(gEleCustomerType.val());
     vUpdateInfoObj.subject = $.trim(gEleSubject.val());

     return vUpdateInfoObj;
  }

  //hàm kiểm tra dữ liệu 
  function validateFormData(paramUserDataObj){
     if(paramUserDataObj.firstname == ""){
          alert("Bạn cần nhập Firstname!!!");
          return false;
     }
     if(paramUserDataObj.lastname == ""){
          alert("Bạn cần nhập Lastname!!!");
          return false;
     }
     if(paramUserDataObj.subject == ""){
          alert("Bạn cần nhập Subject!!!");
          return false;
     }
     if(paramUserDataObj.country == ""){
          alert("Bạn cần nhập Country!!!");
          return false;
     }
     if(paramUserDataObj.customerType == ""){
          alert("Bạn cần nhập Customer Type!!!");
          return false;
     }
     return true;
  }

  //hàm gọi api
  function callAjaxAPIUpdateUser(paramUserDataObj){
     "use strict"
     //b1: lấy dữ liệu từ userid
     var vUserId = getCurrentUserId();

     //bước 2: kiểm tra dữ liệu (bỏ qua )
     //bước 3: hiển thị dữ liệu
     var vJsonString = JSON.stringify(paramUserDataObj);

     $.ajax({
          url: gBASE_URL + vUserId,
          type: "PUT",
          contentType: "application/json; charset-utf-8",
          data: vJsonString,
          success: function(paramResponse){
               alert("User id: " + paramResponse.id + "\n cập nhật thông tin thành công!");

               //khi cập nhật thành công quay trở lai trang danh sách người dùng 
               window.location.href = "insertUser.html";

               console.log(JSON.stringify(paramResponse, true, 2));
          }, 
          error: function(ajaxContext){
               console.log(ajaxContext);
          }
     });
  }

  //hàm thu thập thông tin đang gửi hiện tại 
  function getCurrentUserId(){
     var vId = null;
     var vUrl = new URL(window.location.href); //vUrl trở thành 1 object

     vId = vUrl.searchParams.get("id");
     return vId;
  }
</script>
</html>